#include <IRremote.h>

int RECV_PIN = 6; //вход ИК приемника
IRrecv irrecv(RECV_PIN);
decode_results results;
int OUT_1 = 2;  //выход на светодиод
int OUT_2 = 3;  //выход на светодиод
int OUT_3 = 4;  //выход на светодиод
int OUT_4 = 5;  //выход на светодиод
int OUT_5 = 7;  //выход на светодиод
int OUT_6 = 8;  //выход на светодиод
int OUT_7 = 9;  //выход на светодиод
int LED = 13;
int IN_U_pin = 11;  //вход от датчика напряжения
int IN_S_pin = 0;  //вход от датчика освещения
int BUZ = 10;        //выход на зумер

int IN_S = 0;
int IN_U = 0;
int IN_IN = 1;

unsigned long previousMillis_T1 = 0;   // время включения 1 светодиода
unsigned long previousMillis_T2 = 0;   // время включения 2 светодиода
unsigned long previousMillis_T3 = 0;   // время включения 3 светодиода
unsigned long previousMillis_T4 = 0;   // время включения 4 светодиода
unsigned long previousMillis_T5 = 0;   // время включения 5 светодиода
unsigned long previousMillis_T6 = 0;   // время включения 6 светодиода
unsigned long previousMillis_T7 = 0;   // время включения 7 светодиода
unsigned long currentMillis = 0;
unsigned long previousMillis = 0;      // храним время последнего переключения светодиода
long interval = 10000;                 // время включения светодиодов (10 минут)

void setup() {
  irrecv.enableIRIn();      // включить приемник
  pinMode(OUT_1, OUTPUT);   //Порт на выход
  pinMode(OUT_2, OUTPUT);   //Порт на выход
  pinMode(OUT_3, OUTPUT);   //Порт на выход
  pinMode(OUT_4, OUTPUT);   //Порт на выход
  pinMode(OUT_5, OUTPUT);   //Порт на выход
  pinMode(OUT_6, OUTPUT);   //Порт на выход
  pinMode(OUT_7, OUTPUT);   //Порт на выход
  pinMode(LED, OUTPUT);     //Порт на выход
  pinMode(IN_U, INPUT);     //Порт на вход
  pinMode(IN_S, INPUT);     //Порт на вход
  pinMode(BUZ, OUTPUT);     //Порт на выход
  Serial.begin(9600);       // открываем последовательное соединение
}

void loop() {

  //IN_U = digitalRead(IN_U_pin);   //считываем состояние датчика напряжения
  IN_S = analogRead(IN_S_pin);   //считываем состояние датчика освещения

  Serial.println(IN_S);
  //delay(500);

 if (IN_U == 1 || IN_S < 900 )
  {
    digitalWrite(OUT_1, LOW); //  переключаем порты в низкий уровень
    digitalWrite(OUT_2, LOW);
    digitalWrite(OUT_3, LOW);
    digitalWrite(OUT_4, LOW);
    digitalWrite(OUT_5, LOW);
    digitalWrite(OUT_6, LOW);
    digitalWrite(OUT_7, LOW);
    previousMillis = millis();
    IN_IN = 1;
    Serial.print("IN_IN_IN  ");
    Serial.print(IN_IN);
    Serial.println();
  }
  
  if ( IN_U == 0 && IN_S > 950 && IN_IN == 1)  //если пропало напряжение и уже вечер и пременная IN_IN равна 1
  {
    digitalWrite(OUT_1, HIGH);  //  переключаем порты в высокий уровень
    digitalWrite(OUT_2, HIGH);
    digitalWrite(OUT_3, HIGH);
    digitalWrite(OUT_4, HIGH);
    digitalWrite(OUT_5, HIGH);
    digitalWrite(OUT_6, HIGH);
    digitalWrite(OUT_7, HIGH);
    
    //tone (BUZ, 1000, 300);

    currentMillis = millis();

    //проверяем не прошел ли нужный интервал, если прошел то
    if (currentMillis - previousMillis > 20000) {
      // сохраняем время последнего переключения
      previousMillis = currentMillis;
      digitalWrite(OUT_1, LOW); // и переключаем порты в низкий уровень
      digitalWrite(OUT_2, LOW);
      digitalWrite(OUT_3, LOW);
      digitalWrite(OUT_4, LOW);
      digitalWrite(OUT_5, LOW);
      digitalWrite(OUT_6, LOW);
      digitalWrite(OUT_7, LOW);
      IN_IN = 0;
      Serial.print("PUNKT_2  IN_IN   ");
      Serial.println(IN_IN);
      //delay(700);
      Serial.println(IN_IN);
    }
    if (irrecv.decode(&results)) // если пришел код кнопки
    {
      if (results.value == 0x20DF10EF || results.value == 0x20DF10E0)//код  кнопки "Выключить ВСЁ"
      {
        digitalWrite(OUT_1, HIGH);  // кроме этого порта все остальные
        digitalWrite(OUT_2, LOW);   // переключаем порты в низкий уровень
        digitalWrite(OUT_3, LOW);
        digitalWrite(OUT_4, LOW);
        digitalWrite(OUT_5, LOW);
        digitalWrite(OUT_6, HIGH);
        digitalWrite(OUT_7, LOW);
        IN_IN = 0;
        previousMillis_T1 = millis();
        digitalWrite(BUZ, HIGH);
        delay(100);
        digitalWrite(BUZ, LOW);
      }
      irrecv.resume();   //получить следующее значение
    }

    // Serial.println(IN_U);
    //Serial.println(IN_IN);
    // Serial.println(IN_IN);
  }

  if ( IN_U == 0 && IN_S > 910 && IN_IN == 0)  //если пропало напряжение и уже вечер и пременная IN_IN равна 0
  {
    if (irrecv.decode(&results)) // если пришел код кнопки
    {
      if (results.value == 0x20DF8877 || results.value == 0x20DF8872) //код моей кнопки "20DF8877". У Вас он будет дугой
      {
        digitalWrite(OUT_1, HIGH);
        Serial.println("A");
        previousMillis_T1 = millis();
        digitalWrite(BUZ, HIGH);
        delay(100);
        digitalWrite(BUZ, LOW);
      }

      if (results.value == 0x20DF48B7 || results.value == 0x20DF8872) //код моей кнопки "20DF48B7".
      {
        digitalWrite(OUT_2, HIGH);
        Serial.print("B");
        previousMillis_T2 = millis();
        digitalWrite(BUZ, HIGH);
        delay(100);
        digitalWrite(BUZ, LOW);
      }

      if (results.value == 0x20DFC837 || results.value == 0x20DF8872)//код моей кнопки "20DF10EF".
      {
        digitalWrite(OUT_3, HIGH);
        Serial.println("C");
        previousMillis_T3 = millis();
        digitalWrite(BUZ, HIGH);
        delay(100);
        digitalWrite(BUZ, LOW);
      }

      if (results.value == 0x20DF28D7 || results.value == 0x20DF8872) //код моей кнопки "20DF8877".
      {
        digitalWrite(OUT_4, HIGH);
        Serial.print("D");
        previousMillis_T4 = millis();
        digitalWrite(BUZ, HIGH);
        delay(100);
        digitalWrite(BUZ, LOW);
      }

      if (results.value == 0x20DFA857 || results.value == 0x20DF8872) //код моей кнопки "20DF8877".
      {
        digitalWrite(OUT_5, HIGH);
        Serial.print("E");
        previousMillis_T5 = millis();
        digitalWrite(BUZ, HIGH);
        delay(100);
        digitalWrite(BUZ, LOW);
      }

      if (results.value == 0x20DF6897 || results.value == 0x20DF8872) //код моей кнопки "20DF8877".
      {
        digitalWrite(OUT_6, HIGH);
        Serial.print("F");
        previousMillis_T6 = millis();
        digitalWrite(BUZ, HIGH);
        delay(100);
        digitalWrite(BUZ, LOW);
      }

      if (results.value == 0x20DFE817 || results.value == 0x20DF8872) //код моей кнопки "20DF8877".
      {
        digitalWrite(OUT_7, HIGH);
        Serial.print("G");
        previousMillis_T7 = millis();
        digitalWrite(BUZ, HIGH);
        delay(100);
        digitalWrite(BUZ, LOW);
      }
      if (results.value == 0x20DF10EF || results.value == 0x20DF8872)//код  кнопки "Выключить ВСЁ"
      {
        digitalWrite(OUT_1, LOW); //низкий уровень
        digitalWrite(OUT_2, LOW);
        digitalWrite(OUT_3, LOW);
        digitalWrite(OUT_4, LOW);
        digitalWrite(OUT_5, LOW);
        digitalWrite(OUT_6, LOW);
        digitalWrite(OUT_7, LOW);
        digitalWrite(BUZ, HIGH);
        delay(100);
        digitalWrite(BUZ, LOW);
        //Serial.println("H");
      }
      //IN_IN = 1;
      irrecv.resume();   //получить следующее значение
    }
    currentMillis = millis();

    //проверяем не прошел ли нужный интервал, если прошел то
    if (currentMillis - previousMillis_T1 > interval) {
      digitalWrite(OUT_1, LOW); // и переключаем порты в низкий уровень
      previousMillis_T1 = currentMillis;
    }
    if (currentMillis - previousMillis_T2 > interval) {
      digitalWrite(OUT_2, LOW);
      previousMillis_T2 = currentMillis;
    }

    if (currentMillis - previousMillis_T3 > interval) {
      digitalWrite(OUT_3, LOW);
      previousMillis_T3 = currentMillis;
    }

    if (currentMillis - previousMillis_T4 > interval) {
      digitalWrite(OUT_4, LOW);
      previousMillis_T4 = currentMillis;
    }

    if (currentMillis - previousMillis_T5 > interval) {
      digitalWrite(OUT_5, LOW);
      previousMillis_T5 = currentMillis;
    }

    if (currentMillis - previousMillis_T6 > interval)  {
      digitalWrite(OUT_6, LOW);
      previousMillis_T6 = currentMillis;
    }

    if (currentMillis - previousMillis_T7 > interval) {
      digitalWrite(OUT_7, LOW);
      previousMillis_T7 = currentMillis;
      delay(7);
    }

  }
}
